<?php
class sbcModules {

	private $_modulesConfiguration = array();

	/* [CONSTRUCTOR] */
	function __construct($type = null) {
		$modulesConfiguration = require('/usr/local/php/include/modulesConfiguration.php');
		if (is_null($type) || !isset($modulesConfiguration['type'])) {
			foreach ($modulesConfiguration as $modConf) {
				$this->_modulesConfiguration = array_merge($this->_modulesConfiguration, $modConf);
			}
		}
		else {
			$this->_modulesConfiguration = $modulesConfiguration[$type];
		}
	}

	/* [PUBLIC - GENERAL METHODS] */
	public function getConfigurations($type = null) {
		if (isset($this->_modulesConfiguration[$type])) {
			return $this->_modulesConfiguration[$type];
		}
		return $this->_modulesConfiguration;
	}

	public function getList() {
		return array_keys($this->_modulesConfiguration);
	}

	public function getTdmPorts($type, &$module = null) {
		if (isset($this->_modulesConfiguration[$type])) {
			$ports = $this->_modulesConfiguration[$type]['tdm']['ports'];
			$module = str_replace("bf$port", "", $type);
			return $ports;
		}
		else if (isset($this->_modulesConfiguration["bf$type"])) {
			$module = substr($type, 1);
			return $this->_modulesConfiguration["bf$type"]['tdm']['ports'];
		}
		else if (preg_match('/^(bf)?([0-9]+)(.*)$/', $type, $matched)) {
			$module = $matched[3];
			return $matched[2];
		}
		// should not happen
		$module = 'unknown';
		return -1;
	}
}
?>
